#ifndef DBUS_H_
#define DBUS_H_

#include <QObject>
#include <QList>
#include <QVariant>

namespace kdk
{
namespace kabase
{

class DBus
{
public:
    DBus();
    ~DBus();

    /**
     * @brief 注册服务
     *
     * @param serviceName 服务名
     *
     * @retval true 成功
     * @retval false 失败
     */
    static bool registerService(QString serviceName);

    /**
     * @brief 注册对象
     *
     * @param objectPath 对象路径
     * @param object 要注册的对象指针
     *
     * @retval true 成功
     * @retval false 失败
     */
    static bool registerObject(QString objectPath, QObject *object);

    /**
     * @brief 函数调用
     *
     * @param serviceName 服务名
     * @param objectPath 对象路径
     * @param interfaceName 接口名
     * @param methodName 函数名
     * @param args 参数列表
     *
     * @return 函数返回值
     */
    static QList<QVariant> callMethod(QString serviceName, QString objectPath, QString interfaceName,
                                      QString methodName, QList<QVariant> args = QList<QVariant>());
};

} /* namespace kabase */
} /* namespace kdk */

#endif